<template>
  <div class="d-flex flex-column px-md-16 px-4 w-100">
    <div class="d-flex flex-sm-row flex-column align-center justify-space-between w-100 py-8">
      <div class="d-flex flex-column">
        <h2>Rollen verwalten</h2>
        <span>Hier kannst du die Rollen verwalten.</span>
      </div>

      <div class="d-flex flex-row mt-sm-0 mt-8 ml-sm-4">
        <RoleCreate @submitted="loadRoles()" />
      </div>
    </div>

    <v-container class="pa-0 ma-0">
      <v-row>
        <v-col cols="12" xl="3" lg="4" md="6" sm="12" v-for="role of roles" :key="role.id">
          <v-card :title="role.name" :subtitle="getSubtitle(role)" link>
            <v-card-actions class="d-flex justify-end mt-n4">
              <RolePatch :role="role" @submitted="loadRoles()" />
              <RoleDelete :role="role" @submitted="loadRoles()" />
            </v-card-actions>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, ref } from "vue";

import { api, RoleResponse } from "../../api";

import RoleCreate from "../../components/RoleCreate.vue";
import RoleDelete from "../../components/RoleDelete.vue";
import RolePatch from "../../components/RolePatch.vue";

const roles = ref<RoleResponse[]>([]);

function getSubtitle(role: RoleResponse): string {
  const rightsCount = role._count.rights || 0;
  const usersCount = role._count.users || 0;
  return `Benutzer: ${usersCount} | Rollen Berechtigungen: ${rightsCount}`;
}

async function loadRoles(): Promise<void> {
  const { data, status, statusText } = await api.roles.getAllRoles();

  if (status !== 200) {
    console.error(statusText);
    return;
  }
  roles.value = data;
}

onMounted(loadRoles);
</script>
